//########## Saucer

//### Sounds

datablock AudioProfile(gc_SaucerEngineSound)
{
  filename = "./saucer.wav";
  description = AudioCloseLooping3d;
  preload = true;
};

datablock AudioProfile(gc_SaucerMGFireSound)
{
  filename = "./mg.wav";
  description = AudioClose3d;
  preload = true;
};

datablock AudioProfile(gc_SaucerMGHitSound)
{
  filename = "./mghit.wav";
  description = AudioClose3d;
  preload = true;
};

datablock AudioProfile(gc_SaucerCannonFireSound)
{
  filename = "./cannon.wav";
  description = AudioDefault3d;
  preload = true;
};

datablock AudioProfile(gc_SaucerCannonExplosionSound)
{
  filename = "./cannonexplosion.wav";
  description = AudioDefault3d;
  preload = true;
};

//### Effects

datablock ParticleData(gc_vehicleDamageParticle)
{
  dragCoefficient = 8;
  gravityCoefficient = -2;
  inheritedVelFactor = 0.2;
  constantAcceleration = 0;
  lifetimeMS = 1000;
  lifetimeVarianceMS = 500;
  textureName = "base/data/particles/cloud";
  spinSpeed = 10;
  spinRandomMin = -50;
  spinRandomMax = 50;
  colors[0] = "0 0 0 0";
  colors[1] = "0 0 0 0.5";
  colors[2] = "0 0 0 0";
  sizes[0] = 3;
  sizes[1] = 4;
  sizes[2] = 6;
  times[0] = 0;
  times[1] = 0.2;
  times[2] = 1;
  useInvAlpha = true;
};

datablock ParticleEmitterData(gc_vehicleDamageEmitter)
{
  uiName = "";
  ejectionPeriodMS = 50;
  periodVarianceMS = 25;
  ejectionVelocity = 2;
  velocityVariance = 1;
  ejectionOffset = 0;
  thetaMin = 89;
  thetaMax = 90;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_vehicleDamageParticle";
  useEmitterColors = true;
};

datablock StaticShapeData(gc_SaucerTrailStatic) { shapeFile = "./bullettrail.dts"; };

function gc_SaucerTrailStatic::onAdd(%this,%obj)
{
  %obj.playThread(0,root);
  %obj.schedule(500,delete);
}

datablock ParticleData(gc_SaucerFlashParticle)
{
  dragCoefficient = 0;
  gravityCoefficient = 0;
  inheritedVelFactor = 1;
  constantAcceleration = 0;
  lifetimeMS = 50;
  lifetimeVarianceMS = 0;
  textureName = "base/data/particles/dot";
  spinSpeed = 50;
  spinRandomMin = -500;
  spinRandomMax = 500;
  colors[0] = "0 1 0 1";
  colors[1] = "0.5 1 0.5 1";
  colors[2] = "0 1 0 0";
  sizes[0] = 0.1;
  sizes[1] = 2;
  sizes[2] = 0;
  times[0] = 0;
  times[1] = 0.1;
  times[2] = 1;
  useInvAlpha = false;
};

datablock ParticleEmitterData(gc_SaucerFlashEmitter)
{
  uiName = "";
  ejectionPeriodMS = 3;
  periodVarianceMS = 0;
  ejectionVelocity = 250;
  velocityVariance = 0;
  ejectionOffset = 0;
  thetaMin = 0;
  thetaMax = 10;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_SaucerFlashParticle";
};

datablock ShapeBaseImageData(gc_SaucerFireImage)
{
  shapeFile = "base/data/shapes/empty.dts";
  emap = false;
  mountPoint = 1;

  stateName[0] = "Fire";
  stateTransitionOnTimeout[0] = "Done";
  stateWaitForTimeout[0] = true;
  stateTimeoutValue[0] = 0.05;
  stateEmitter[0] = gc_SaucerFlashEmitter;
  stateEmitterTime[0] = 0.05;

  stateName[1] = "Done";
  stateScript[1] = "onDone";
};

function gc_SaucerFireImage::onDone(%this,%obj,%slot) { %obj.unMountImage(%slot); }

datablock ParticleData(gc_SaucerMGParticle)
{
  dragCoefficient = 8;
  gravityCoefficient = 0;
  inheritedVelFactor = 0;
  constantAcceleration = 0;
  lifetimeMS = 25;
  lifetimeVarianceMS = 0;
  textureName = "base/data/particles/dot";
  spinSpeed = 10;
  spinRandomMin = -50;
  spinRandomMax = 50;
  colors[0] = "0 1 0 1";
  colors[2] = "0 1 0 0";
  sizes[0] = 0.5;
  sizes[1] = 0;
  useInvAlpha = false;
};

datablock ParticleEmitterData(gc_SaucerMGEmitter)
{
  uiName = "";
  ejectionPeriodMS = 2;
  periodVarianceMS = 0;
  ejectionVelocity = 1;
  velocityVariance = 0;
  ejectionOffset = 0;
  thetaMin = 0;
  thetaMax = 180;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_SaucerMGParticle";
};

datablock ParticleData(gc_SaucerMGExplosionParticle)
{
  dragCoefficient = 0;
  inheritedVelFactor = 0;
  lifetimeMS = 250;
  textureName = "base/data/particles/dot";
  spinSpeed = 0;
  colors[0] = "0.5 1 0.5 1";
  colors[1] = "0 1 0 1";
  sizes[0] = 0.5;
  sizes[1] = 0;
  useInvAlpha = false;
};

datablock ParticleEmitterData(gc_SaucerMGExplosionEmitter)
{
  ejectionPeriodMS = 2;
  ejectionVelocity = 10;
  velocityVariance = 5;
  thetaMin = 0;
  thetaMax = 180;
  phiReferenceVel = 0;
  phiVariance = 360;
  particles = "gc_SaucerMGExplosionParticle";
  uiName = "";
};

datablock ExplosionData(gc_SaucerMGExplosion)
{
  uiName = "";
  particleEmitter = "";
  lifeTimeMS = 100;
  emitter[0] = gc_SaucerMGExplosionEmitter;
  soundProfile = gc_SaucerMGHitSound;
  faceViewer = true;
  explosionScale = "1 1 1";
  shakeCamera = true;
  camShakeFreq = "5 5 5";
  camShakeAmp = "2 2 2";
  camShakeDuration = 0.5;
  camShakeRadius = 2;
};

datablock ParticleData(gc_SaucerCannonExplosionParticle)
{
  dragCoefficient = 2;
  gravityCoefficient = 0;
  inheritedVelFactor = 1;
  constantAcceleration = 0;
  lifetimeMS = 1500;
  lifetimeVarianceMS = 500;
  textureName = "base/data/particles/cloud";
  spinSpeed = 50;
  spinRandomMin = -500;
  spinRandomMax = 500;
  colors[0] = "0.5 1 0.5 1";
  colors[1] = "0.1 0.5 0.1 1";
  colors[2] = "0 0.2 0 0";
  sizes[0] = 15;
  sizes[1] = 10;
  sizes[2] = 8;
  times[0] = 0;
  times[1] = 0.1;
  times[2] = 1;
  useInvAlpha = true;
};

datablock ParticleEmitterData(gc_SaucerCannonExplosionEmitter)
{
  uiName = "";
  ejectionPeriodMS = 5;
  periodVarianceMS = 0;
  ejectionVelocity = 10;
  velocityVariance = 10;
  ejectionOffset = 0.5;
  thetaMin = 0;
  thetaMax = 180;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_SaucerCannonExplosionParticle";
};

datablock ExplosionData(gc_SaucerCannonExplosion)
{
  lifeTimeMS = 250;
  emitter[0] = gc_SaucerCannonExplosionEmitter;
  faceViewer = true;
  explosionScale = "1 1 1";
  lightStartRadius = 10;
  lightEndRadius = 0;
  lightStartColor = "0.1 1 0.1";
  lightEndColor = "0 0 0";
  damageRadius = 6;
  radiusDamage = 200;
  impulseRadius = 12;
  impulseForce = 300;
  soundProfile = gc_SaucerCannonExplosionSound;
  shakeCamera = true;
  camShakeFreq = "5 5 5";
  camShakeAmp = "8 8 8";
  camShakeDuration = 2;
  camShakeRadius = 18;
};

datablock ParticleData(gc_SaucerExplosionParticle)
{
  dragCoefficient = 0;
  gravityCoefficient = 0;
  inheritedVelFactor = 0.2;
  constantAcceleration = 0;
  lifetimeMS = 150;
  lifetimeVarianceMS = 50;
  textureName = "base/data/particles/star1";
  spinSpeed = 10;
  spinRandomMin = -50;
  spinRandomMax = 50;
  colors[0] = "1 0.6 0.2 1";
  colors[1] = "1 0 0 0";
  sizes[0] = 25;
  sizes[1] = 15;
  useInvAlpha = false;
};

datablock ParticleEmitterData(gc_SaucerExplosionEmitter)
{
  uiName = "";
  ejectionPeriodMS = 2;
  periodVarianceMS = 0;
  ejectionVelocity = 5;
  velocityVariance = 0;
  ejectionOffset = 5;
  thetaMin = 0;
  thetaMax = 180;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_SaucerExplosionParticle";
};

datablock ParticleData(gc_SaucerSmokeParticle)
{
  dragCoefficient = 15;
  gravityCoefficient = -0.5;
  inheritedVelFactor = 0.2;
  constantAcceleration = 0;
  lifetimeMS = 3000;
  lifetimeVarianceMS = 1000;
  textureName = "base/data/particles/cloud";
  spinSpeed = 0;
  spinRandomMin = -1;
  spinRandomMax = 1;
  colors[0] = "0 0 0 1";
  colors[1] = "0 0 0 0";
  sizes[0] = 10;
  sizes[1] = 20;
  useInvAlpha = true;
  windCoefficient = 1;
};

datablock ParticleEmitterData(gc_SaucerSmokeEmitter)
{
  uiName = "";
  ejectionPeriodMS = 4;
  periodVarianceMS = 0;
  ejectionVelocity = 100;
  velocityVariance = 100;
  ejectionOffset = 2.5;
  thetaMin = 0;
  thetaMax = 180;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_SaucerSmokeParticle";
};

datablock ExplosionData(gc_SaucerExplosion : vehicleFinalExplosion)
{
  emitter[0] = gc_SaucerExplosionEmitter;
  emitter[1] = gc_SaucerSmokeEmitter;
  uiName = "";
  debrisNum = 0;
  debrisNumVariance = 0;
};

datablock ProjectileData(gc_SaucerExplosionProjectile : vehicleFinalExplosionProjectile)
{
  uiName = "";
  explosion = gc_SaucerExplosion;
};

//### Projectile

AddDamageType("Saucer",'<bitmap:Add-Ons/Vehicle_Saucers/CI_saucer>%1','%2<bitmap:Add-Ons/Vehicle_Saucers/CI_saucer>%1',1,1);

datablock ProjectileData(gc_SaucerMGProjectile)
{
  uiName = "";
  projectileShapeName = "";
  directDamage = 10;
  directDamageType = $DamageType::Saucer;
  radiusDamageType = $DamageType::Saucer;
  impactImpulse = 100;
  explosion = gc_SaucerMGExplosion;
  muzzleVelocity = 200;
  particleEmitter = gc_SaucerMGEmitter;
  verInheritFactor = 1;
  armingDelay = 0;
  lifetime = 5000;
  fadeDelay = 5000;
  bounceElasticity = 0.5;
  bounceFriction = 0.2;
};

datablock ProjectileData(gc_SaucerCannonProjectile)
{
  uiName = "";
  projectileShapeName = "";
  directDamage = 200;
  directDamageType = $DamageType::Saucer;
  radiusDamageType = $DamageType::Saucer;
  brickExplosionRadius = 5;
  brickExplosionImpact = true;
  brickExplosionForce = 25;
  brickExplosionMaxVolume = 60;
  brickExplosionMaxVolumeFloating = 60;
  impactImpulse = 100;
  explosion = gc_SaucerCannonExplosion;
  muzzleVelocity = 200;
  armingDelay = 0;
  lifetime = 1;
  fadeDelay = 1;
  explodeOnDeath = 1;
};

//### Turrets

datablock TSShapeConstructor(saucermgDts)
{
  baseShape = "./mg.dts";
  sequence0 = "./mg_root.dsq root";
  sequence1 = "./mg_look.dsq look";
  sequence2 = "./mg_spin.dsq spin";
};

datablock TSShapeConstructor(saucercannonDts)
{
  baseShape = "./cannon.dts";
  sequence0 = "./cannon_root.dsq root";
  sequence1 = "./cannon_look.dsq look";
};

datablock PlayerData(gc_SaucerMGTurretPlayer)
{
  renderFirstPerson = true;
  emap = false;
  className = Armor;
  shapeFile = "./mg.dts";
  cameraMaxDist = 4;
  cameraTilt = 0;
  cameraVerticalOffset = -4;
  cameraDefaultFov = 90;
  cameraMinFov = 5;
  cameraMaxFov = 120;
  aiAvoidThis = true;
  minLookAngle = -1.5708;
  maxLookAngle = 1.5708;
  maxFreelookAngle = 3;
  mass = 200000;
  drag = 1;
  density = 5;
  maxDamage = 400;
  maxEnergy = 10;
  repairRate = 0.33;
  rechargeRate = 0.4;
  runForce = 1000;
  runEnergyDrain = 0;
  minRunEnergy = 0;
  maxForwardSpeed = 0;
  maxBackwardSpeed = 0;
  maxSideSpeed = 0;
  maxForwardCrouchSpeed = 0;
  maxBackwardCrouchSpeed = 0;
  maxSideCrouchSpeed = 0;
  maxUnderwaterForwardSpeed = 0;
  maxUnderwaterBackwardSpeed = 0;
  maxUnderwaterSideSpeed = 0;
  jumpForce = 0;
  jumpEnergyDrain = 0;
  minJumpEnergy = 0;
  jumpDelay = 0;
  minJetEnergy = 0;
  jetEnergyDrain = 0;
  canJet = 0;
  minImpactSpeed = 250;
  speedDamageScale = 3.8;
  boundingBox = "2 2 -2";
  crouchBoundingBox = "2 2 -2";
  pickupRadius = 0.75;
  jetEmitter = "";
  jetGroundEmitter = "";
  jetGroundDistance = 4;
  splash = PlayerSplash;
  splashVelocity = 4;
  splashAngle = 67;
  splashFreqMod = 300;
  splashVelEpsilon = 0.6;
  bubbleEmitTime = 0.1;
  splashEmitter[0] = PlayerFoamDropletsEmitter;
  splashEmitter[1] = PlayerFoamEmitter;
  splashEmitter[2] = PlayerBubbleEmitter;
  mediumSplashSoundVelocity = 10;
  hardSplashSoundVelocity = 20;
  exitSplashSoundVelocity = 5;
  runSurfaceAngle = 85;
  jumpSurfaceAngle = 86;
  minJumpSpeed = 20;
  maxJumpSpeed = 30;
  horizMaxSpeed = 68;
  horizResistSpeed = 33;
  horizResistFactor = 0.35;
  upMaxSpeed = 80;
  upResistSpeed = 25;
  upResistFactor = 0.3;
  footstepSplashHeight = 0.35;
  JumpSound = "";
  groundImpactMinSpeed = 10;
  groundImpactShakeFreq = "4 4 4";
  groundImpactShakeAmp = "1 1 1";
  groundImpactShakeDuration = 0.8;
  groundImpactShakeFalloff = 10;
  maxItems = 10;
  maxWeapons = 5;
  maxTools = 5;
  uiName = "";
  rideable = true;
  lookUpLimit = 0;
  lookDownLimit = 0.5;
  canRide = false;
  showEnergyBar = false;
  paintable = true;
  brickImage = horseBrickImage;
  numMountPoints = 1;
  mountThread[0] = "sit";
  protectPassengersBurn = true;
  protectPassengersRadius = true;
  protectPassengersDirect = true;
  useCustomPainEffects = true;
  PainHighImage = "";
  PainMidImage = "";
  PainLowImage = "";
  painSound = "";
  deathSound = "";
  useEyePoint = 1;
};

datablock PlayerData(gc_SaucerCannonTurretPlayer : gc_SaucerMGTurretPlayer)
{
  renderFirstPerson = true;
  emap = false;
  className = Armor;
  shapeFile = "./cannon.dts";
  uiName = "";
  useEyePoint = 1;
};

//### Vehicle

datablock FlyingVehicleData(gc_SaucerVehicle)
{
  uiName = "Saucer";
  category = "Vehicles";
  displayName = "";
  shapeFile = "./saucer.dts";
  emap = true;
  minMountDist = 4;
  numMountPoints = 4;
  mountThread[0] = "sit";
  mountThread[1] = "sit";
  mountThread[2] = "sit";
  mountThread[3] = "sit";
  mountThread[4] = "sit";
  mass = 400;
  maxDamage = 200;
  destroyedLevel = 200;
  speedDamageScale = 1.04;
  collDamageThresholdVel = 20;
  collDamageMultiplier = 0.02;
  lookUpLimit = 1;
  lookDownLimit = 0;
  jetForce = 500;
  jetEnergyDrain = 8;
  minJetEnergy = 1;
  massCenter = "0 0 0";
  density = 5;
  drag = 1.6;
  bodyFriction = 0.6;
  bodyRestitution = 0.6;
  minImpactSpeed = 25;
  softImpactSpeed = 25;
  hardImpactSpeed = 50;
  minRollSpeed = 0;
  maxSteeringAngle = 0.785;
  maxDrag = 40;
  minDrag = 50;
  integration = 4;
  collisionTol = 0.1;
  contactTol = 0.1;
  cameraRoll = false;
  cameraMaxDist = 15;
  cameraLag = 5;
  cameraDecay = 0;
  cameraOffset = 3;
  cameraTilt = 0;
  damageEmitter[0] = gc_vehicleDamageEmitter;
  damageEmitterOffset[0] = "0 -5 2";
  damageLevelTolerance[0] = 0.5;
  damageEmitter[1] = VehicleBurnEmitter;
  damageEmitterOffset[1] = "0 -5 2";
  damageLevelTolerance[1] = 0.9;
  numDmgEmitterAreas = 1;
  splashFreqMod = 300;
  splashVelEpsilon = 0.5;
  exitSplashSoundVelocity = 2;
  softSplashSoundVelocity = 1;
  mediumSplashSoundVelocity = 2;
  hardSplashSoundVelocity = 3;
  rideable = true;
  paintable = true;
  maneuveringForce = 8000;
  horizontalSurfaceForce = 10;
  verticalSurfaceForce = 100;
  autoInputDamping = 0.95;
  steeringForce = 3000;
  steeringRollForce = 0;
  rollForce = 400;
  autoAngularForce = 6000;
  rotationalDrag = 25;
  autoLinearForce = 100;
  maxAutoSpeed = 50;
  hoverHeight = 3;
  createHoverHeight = 3;
  vertThrustMultiple = 1;
  initialExplosionProjectile = gc_SaucerExplosionProjectile;
  initialExplosionOffset = 0;
  burnTime = 5000;
  finalExplosionProjectile = gc_SaucerExplosionProjectile;
  finalExplosionOffset = 0;
  minRunOverSpeed = 5;
  runOverDamageScale = 5;
  runOverPushScale = 1.2;
  protectPassengersBurn = true;
  protectPassengersRadius = true;
  protectPassengersDirect = true;
  heightcontrol = 1;
  ascendVelocity = 0.5;
  descendVelocity = -0.5;
};

datablock FlyingVehicleData(gc_SaucerMGVehicle : gc_SaucerVehicle)
{
  uiName = "Saucer - MG";
  numMountPoints = 5;
};

datablock FlyingVehicleData(gc_SaucerCannonVehicle : gc_SaucerVehicle)
{
  uiName = "Saucer - Cannon";
  numMountPoints = 5;
};

function gc_SaucerVehicle::onAdd(%this,%obj)
{
  %obj.PlayAudio(0,gc_SaucerEngineSound);
}

function gc_SaucerMGVehicle::onAdd(%this,%obj)
{
  %obj.PlayAudio(0,gc_SaucerEngineSound);
  %t = new AIPlayer() { dataBlock = gc_SaucerMGTurretPlayer; };
  MissionCleanup.add(%t);
  %obj.mountObject(%t,4);
  %obj.turret = %t;
}

function gc_SaucerCannonVehicle::onAdd(%this,%obj)
{
  %obj.PlayAudio(0,gc_SaucerEngineSound);
  %t = new AIPlayer() { dataBlock = gc_SaucerCannonTurretPlayer; };
  MissionCleanup.add(%t);
  %obj.mountObject(%t,4);
  %obj.turret = %t;
}

function gc_SaucerMGVehicle::onRemove(%this,%obj) { if(isObject(%obj.turret)) { %obj.turret.delete(); } }
function gc_SaucerCannonVehicle::onRemove(%this,%obj) { if(isObject(%obj.turret)) { %obj.turret.delete(); } }

package gc_SaucerPackage
{
  function Player::Burn(%obj,%time)
  {
    if(%obj.dataBlock $= gc_SaucerMGTurretPlayer) return;
    if(%obj.dataBlock $= gc_SaucerCannonTurretPlayer) return;
    parent::Burn(%obj,%time);
  }
  function ShapeBase::setNodeColor(%obj,%node,%color)
  {
    parent::setnodecolor(%obj,%node,%color);
    if(isObject(%obj.turret)) %obj.turret.setNodeColor("ALL",%color);
  }
  function Player::emote(%obj,%emote)
  {
    if(%obj.dataBlock $= gc_SaucerMGTurretPlayer) return;
    if(%obj.dataBlock $= gc_SaucerCannonTurretPlayer) return;
    parent::emote(%obj,%emote);
  }
  function gc_SaucerMGTurretPlayer::Damage(%this,%obj,%source,%pos,%amount,%type) { parent::Damage(%this,%obj,%source,%pos,0,%type); }
  function gc_SaucerCannonTurretPlayer::Damage(%this,%obj,%source,%pos,%amount,%type) { parent::Damage(%this,%obj,%source,%pos,0,%type); }
  function armor::onMount(%this,%obj,%col,%slot)
  {
    parent::onMount(%this,%obj,%col,%slot);
    if(isObject(%obj.client))
    {
      if(%col.getDataBlock() == gc_SaucerMGTurretPlayer.getId()) ServerCmdUnUseTool(%obj.client);
      if(%col.getDataBlock() == gc_SaucerCannonTurretPlayer.getId()) ServerCmdUnUseTool(%obj.client);
    }
  }
  function armor::onTrigger(%this,%obj,%triggerNum,%val)
  {
    %mount = %obj.getObjectMount();
    if(isObject(%mount))
    {
      if(!%val) cancel(%obj.gc_SaucerMGLoop);
      if(%mount.getDataBlock() == gc_SaucerMGTurretPlayer.getId() && %triggerNum == 0 && %val) %obj.gc_SaucerMGFire(%val);
      else if(%mount.getDataBlock() == gc_SaucerCannonTurretPlayer.getId() && %triggerNum == 0 && %val)
      {
        %client = %obj.client;
        if(isObject(%client)) ServerCmdUnUseTool(%client);
        if(getSimTime() - %obj.lastShotTime < 3000) return;
        %scaleFactor = getWord(%mount.getScale(),2);

        %range = 1000;
        %tracer = 5;
        %velocity = VectorNormalize(%mount.getMuzzleVector(1));
        %raycast = containerRayCast(%mount.getSlotTransform(1),VectorAdd(%mount.getSlotTransform(1),VectorScale(%velocity,1000)),$TypeMasks::InteriorObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::ForceFieldObjectType | $TypeMasks::VehicleObjectType | $TypeMasks::PlayerObjectType | $TypeMasks::fxBrickObjectType | $TypeMasks::StaticObjectType,%obj);
        if(isObject(firstWord(%raycast)))
        {
          %p = new Projectile()
          {
            dataBlock = gc_SaucerCannonProjectile;
            initialPosition = VectorSub(posFromRaycast(%raycast),%velocity);
            initialVelocity = VectorScale(%velocity,100);
            sourceObject = %obj;
            sourceSlot = 0;
            client = %obj.client;
          };
          MissionCleanup.add(%p);
        }
        %p = new StaticShape() { dataBlock = gc_SaucerTrailStatic; };
        MissionCleanup.add(%p);
        %x = getWord(%velocity,0)/2;
        %y = (getWord(%velocity,1) + 1)/2;
        %z = getWord(%velocity,2)/2;
        %p.setTransform(getWords(%mount.getSlotTransform(1),0,2) SPC VectorNormalize(%x SPC %y SPC %z) SPC mDegToRad(180));
        %p.setScale(%tracer * %scaleFactor SPC vectorDist(%mount.getSlotTransform(1),posFromRaycast(%raycast)) SPC %tracer * %scaleFactor);

        %obj.lastShotTime = getSimTime();
        %mount.mountImage(gc_SaucerFireImage,1);
        %mount.playThread(0,fire);
        serverPlay3D(gc_SaucerCannonFireSound,%obj.getPosition());
        return;
      }
    }
    parent::onTrigger(%this,%obj,%triggerNum,%val);
  }
  function Player::gc_SaucerMGFire(%obj,%val)
  {
    if(!%val) { cancel(%obj.gc_SaucerMGLoop); return; }
    if(!isObject(%obj.getObjectMount())) { cancel(%obj.gc_SaucerMGLoop); return; }
    if(%obj.getObjectMount().getDataBlock() != gc_SaucerMGTurretPlayer.getId()) { cancel(%obj.gc_SaucerMGLoop); return; }
    %client = %obj.client;
    if(isObject(%client)) ServerCmdUnUseTool(%client);
    %mount = %obj.getObjectMount();
    %scaleFactor = getWord(%mount.getScale(),2);
    %p = new Projectile()
    {
      dataBlock = gc_SaucerMGProjectile;
      initialPosition = %mount.getSlotTransform(1);
      initialVelocity = MatrixMulVector(MatrixCreateFromEuler(((getRandom()-0.5)*0.01) SPC ((getRandom()-0.5)*0.01) SPC ((getRandom()-0.5)*0.01)),VectorScale(%mount.getMuzzleVector(1),150));
      sourceObject = %obj;
      client = %client;
      sourceSlot = 0;
      originPoint = %mount.getSlotTransform(1);
    };
    MissionCleanup.add(%p);
    %p.setScale(%scaleFactor SPC %scaleFactor SPC %scaleFactor);
    %mount.mountImage(gc_SaucerFireImage,1);
    %mount.playThread(0,fire);
    serverPlay3D(gc_SaucerMGFireSound,%obj.getPosition());
    %obj.gc_SaucerMGLoop = %obj.schedule(100,gc_SaucerMGFire,%val);
  }
};
activatepackage(gc_SaucerPackage);
